module SyncTrigger
(
   Trg_Lv_UP, Trg_Lv_DOWN,
   DATA_IN_A, DATA_IN_B,
   SYNC_A_B, Sync_OUT_WIN,
   Start_RW, EN,
   H_OFF, syncON,
   DFF_IN,
   SlCntEN,
   CLK,   
   
   frst_event, lst_event, sync_state,
     
   TRG,   
   C_IN
);

input [7:0]  Trg_Lv_UP, Trg_Lv_DOWN;
input [7:0]  DATA_IN_A, DATA_IN_B;
input SYNC_A_B, Sync_OUT_WIN;
input Start_RW, EN;
input H_OFF, syncON, DFF_IN, C_IN;
input SlCntEN;
input CLK;

output reg TRG;

output sync_state;

output reg frst_event, lst_event;
reg [2:0] SlCounter, SlowCounterRun;


wire [7:0] DATA_SYNC = (SYNC_A_B == 0)? DATA_IN_A : DATA_IN_B;
wire sync_state = (Trg_Lv_UP > DATA_SYNC) & (Trg_Lv_DOWN < DATA_SYNC)? ~Sync_OUT_WIN : Sync_OUT_WIN;

wire TRG_EN = (((H_OFF | DFF_IN) | syncON) & (frst_event & lst_event)) | ~syncON;

wire SlCounterEN = SlCntEN & SlowCounterRun & frst_event;


always @(posedge CLK) begin

if((Start_RW == 0) | (C_IN == 1)) begin
     frst_event <= 0;
     lst_event <= 0;
     SlowCounterRun <= 1;
     SlCounter <= 7;
     if(Start_RW == 0)TRG <= 0;
end
else begin
          
     if(EN == 1) begin    
         if(sync_state == 0) frst_event <= 1;
         
         if(SlCounterEN == 1) begin
             if(SlCounter == 0) begin
                 if(sync_state == 0) begin
                     SlCounter <= 7;                     
                     lst_event <= 0;
                 end    
                 else SlowCounterRun <= 0;
             end
             else SlCounter <= SlCounter - 1; 
         end             
         else if((SlCntEN | SlowCounterRun) == 0) lst_event <= sync_state;                  
     end
     
     if(TRG_EN == 1)TRG <= 1;   
                        
end

end
endmodule






